# Class ExpressionSnippet

java.lang.Object
jdk.jshell.Snippet
jdk.jshell.ExpressionSnippet

public class ExpressionSnippet extends Snippet
Snippet for an assignment or variable-value expression. The Kind is `Snippet.Kind.EXPRESSION`.

`ExpressionSnippet` is immutable: an access to any of its methods will always return the same result. and thus is thread-safe.

See Java Language Specification:
  15 Expressions
Since:
  9

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Snippet

  `Snippet.Kind, Snippet.Status, Snippet.SubKind`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `name()`
  Variable name which is the value of the expression.
  `String`
  `typeName()`
  Type of the expression

  ### Methods declared in class Snippet

  `id, kind, source, subKind`

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### name

    public String name()
    Variable name which is the value of the expression. Since the expression is either just a variable identifier or it is an assignment to a variable, there is always a variable which is the subject of the expression. All other forms of expression become temporary variables which are instead referenced by a `VarSnippet`.
    Returns:
      the name of the variable which is the subject of the expression.

  - ### typeName

    public String typeName()
    Type of the expression
    Returns:
      String representation of the type of the expression.